"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.prodEntry = void 0;
const path_1 = __importDefault(require("path"));
const fs_1 = __importDefault(require("fs"));
const koishi_1 = require("koishi");
const loader_1 = __importDefault(require("@koishijs/loader"));
const logger = new koishi_1.Logger('bootstrap-prod');
async function handlePackageEntry(packagePath) {
    const packagesToRemove = ['koishi', '@koishijs/core', '@koishijs/utils'].map((p) => path_1.default.join(packagePath, 'node_modules', p));
    await Promise.all(packagesToRemove.map(async (path) => {
        try {
            await fs_1.default.promises.access(path);
            logger.info(`Removing ${path} ...`);
            await fs_1.default.promises.rm(path, { recursive: true });
        }
        catch (e) { }
    }));
}
async function prodEntry() {
    logger.info(`Running production preparations...`);
    const config = new loader_1.default().readConfig();
    const plugins = config?.plugins;
    if (!plugins) {
        logger.warn(`No plugins found, exiting.`);
        return;
    }
    const pluginList = Object.keys(plugins).filter((name) => name.startsWith('./'));
    await Promise.all(pluginList.map((name) => handlePackageEntry(name)));
    logger.info(`Done.`);
}
exports.prodEntry = prodEntry;
//# sourceMappingURL=prod.js.map